#include <stdio.h>
#include <utmp.h>
#include <time.h>

int main(int argc, char *argv[])
{
	char *utmpfname = (argc > 1) ? argv[1]:_PATH_UTMP;
	struct utmp *utp;
	struct tm *tmp;

	utmpname(utmpfname);
	setutent();
	while((utp = getutent()) != NULL) {
		if(!(tmp = localtime((time_t *)&utp->ut_tv.tv_sec))) {
			continue;
		}
		printf("type=%d pid=%d line=%s id=%s user=%s\n",
			utp->ut_type, utp->ut_pid, utp->ut_line,
			utp->ut_id, utp->ut_user);
		printf("\thost=%s exit=%d/%d session=%d\n",
			utp->ut_host, utp->ut_exit.e_termination,
			utp->ut_exit.e_exit, utp->ut_session);
		printf("\ttime=%d.%06d (%04d/%02d/%02d %02d:%02d)\n",
			utp->ut_tv.tv_sec, utp->ut_tv.tv_usec,
			tmp->tm_year+1900, tmp->tm_mon+1, tmp->tm_mday,
			tmp->tm_hour, tmp->tm_min);
	}
	endutent();
	return 0;
}
